program ArsClip;



uses
  Forms,
  Windows,
  SysUtils,
  Dialogs,
  Math,
  UnitFolderWriteTest in 'UnitFolderWriteTest.pas',
  UnitMisc in 'UnitMisc.pas',
  UnitFrmMainPopup in 'UnitFrmMainPopup.pas' {FrmMainPopup},
  UnitFrmConfig in 'UnitFrmConfig.pas' {FrmConfig},
  UnitFrmSysTrayMenu in 'UnitFrmSysTrayMenu.pas' {frmSysTrayMenu},
  UnitFrmClipboardManager in 'UnitFrmClipboardManager.pas' {frmClipboardManager},
  UnitListBoxMover in 'UnitListBoxMover.pas',
  UnitFrmPasteSelected in 'UnitFrmPasteSelected.pas' {FrmPasteSelected},
  UnitClipQueue in 'UnitClipQueue.pas',
  UnitFrmAbout in 'UnitFrmAbout.pas' {FrmAbout},
  UnitOtherQueue in 'UnitOtherQueue.pas',
  UnitFrmHotKey in 'UnitFrmHotKey.pas' {FrmHotkey},
  UnitKeyboardQuery in 'UnitKeyboardQuery.pas',
  UnitFrmChainWatcher in 'UnitFrmChainWatcher.pas' {FrmChainWatcher},
  UnitFrmPermanentNew in 'UnitFrmPermanentNew.pas' {FrmPermanent},
  UnitHotKey in 'UnitHotKey.pas',
  UnitTooltipPopup in 'UnitTooltipPopup.pas',
  UnitPaste in 'UnitPaste.pas',
  UnitReportError in 'UnitReportError.pas' {FrmReportError},
  UnitToken in 'UnitToken.pas',
  UnitTWideChar in 'UnitTWideChar.pas',
  UnitFrmDummyUnicodeTooltip in 'UnitFrmDummyUnicodeTooltip.pas' {FrmDummyUnicodeTooltip},
  UnitFrmMove in 'UnitFrmMove.pas' {FrmMove},
  UnitSound in 'UnitSound.pas',
  UnitFrmEditItem in 'UnitFrmEditItem.pas' {FrmEditItem},
  UnitMenuItemTagdata in 'UnitMenuItemTagdata.pas',
  UnitSpecialPaths in 'UnitSpecialPaths.pas',
  UnitPopupGenerate in 'UnitPopupGenerate.pas',
  UnitFrmPermanentEdit in 'UnitFrmPermanentEdit.pas' {FrmPermanentEdit},
  UnitFrmDummyClipboardBar in 'UnitFrmDummyClipboardBar.pas' {frmClipboardBar},
  UnitFrmSearch in 'UnitFrmSearch.pas' {frmSearch},
  UnitFrmInstance in 'UnitFrmInstance.pas' {FrmDummyInstance},
  UnitCRC32 in 'UnitCRC32.PAS',
  UnitDestinationList in 'UnitDestinationList.pas',
  UnitTaskArray in 'UnitTaskArray.pas',
  UnitMiscCom in 'UnitMiscCom.pas',
  UnitFrmJumpList in 'UnitFrmJumpList.pas' {FrmJumpList},
  UnitFrmEditTextExternal in 'UnitFrmEditTextExternal.pas' {frmEditTextExternal},
  UnitFrmNewEditHistory in 'UnitFrmNewEditHistory.pas' {frmEditHistory},
  UnitIntegrity in 'UnitIntegrity.pas',
  UnitClipMenu in 'UnitClipMenu.pas' {FrameItemMenu: TFrame},
  UnitFramePopup in 'UnitFramePopup.pas' {ACPopup: TFrame},
  UnitACPopupClicks in 'UnitACPopupClicks.pas',
  UnitFrmPreviewPopup in 'UnitFrmPreviewPopup.pas' {frmPreviewPopup},
  UnitFrmTooltipNew in 'UnitFrmTooltipNew.pas' {FrmTooltipNew},
  UnitFrmTriggerWindow in 'UnitFrmTriggerWindow.pas' {FrmTriggerWindow},
  UnitFrameMySlide in '..\MySlideTest2\UnitFrameMySlide.pas' {MySlide: TFrame},
  UnitFrmPermanentPreview in 'UnitFrmPermanentPreview.pas' {FrmPermanentPreview},
  UnitFrmCheckForUpdate in '..\CheckForUpdate\UnitFrmCheckForUpdate.pas' {FrmCheckForUpdate},
  UnitDropFile in 'UnitDropFile.pas',
  UnitFrmSizeRichtext in 'UnitFrmSizeRichtext.pas' {frmSizeRichtext},
  UnitFrmClipMenuNew in 'UnitFrmClipMenuNew.pas' {FrmClipMenuNew},
  UnitFrameClipDisplay in 'UnitFrameClipDisplay.pas' {FrameClipDisplay: TFrame},
  UnitHTMLConvert in 'UnitHTMLConvert.pas',
  UnitDragClip in 'UnitDragClip.pas',
  UnitFileCatch in 'UnitFileCatch.pas',
  UnitFrmDummyAlwaysOnTopFix in 'UnitFrmDummyAlwaysOnTopFix.pas' {FrmDummyAllwaysOnTopFix};

{$R *.res}
{$R icon.res}

var ci : TClipITem;
    par : string;

    DefaultParam : boolean;
begin
    DefaultParam := false;

    par := '';
    if ParamCount = 1 then begin
        par := lowercase(ParamStr(1));
    end;

    if par = '-popup' then begin
        Application.OnException := FrmMainPopup.ApplicationException;
        FrmInstance_Init(INST_POPUP);
        Application.ProcessMessages;
        //Application.Run;
        //EXIT;
    end else if par = '-second' then begin
        // a second instance does not get a FrmInstance messege window
    end else begin
        DefaultParam := true;
    end;
    if DefaultParam then begin
        FrmInstance_Init(INST_INIT);

        if not FrmInstance_IsFirst then  begin
            // detect Jump List data
            if par = '' then begin
                Frminstance_Init(INST_DEFAULT);
            end else begin
                FrmInstance_init(par);
            end;
            Application.ProcessMessages;
        end;
    end;





    if not Application.Terminated then begin
        Application.Title := 'ArsClip';
        Application.Initialize;

        Application.MainFormOnTaskBar := true;    // while this seems backwards, it prevents a ghost taskbar window
        Application.ShowMainForm := false;



        {Bad things happen if the "application form" isn't hidden}
//        ShowWindow(Application.Handle, SW_HIDE);
//        SetWindowLong(Application.Handle, GWL_EXSTYLE,
//        GetWindowLong(Application.Handle, GWL_EXSTYLE) or WS_EX_TOOLWINDOW);


        //Application.CreateForm(TFrmMainpopup, FrmMainpopup);
        // this is WRONG, don't let the IDE change it from TPopupGenerator

        AppendLog('Starting');
        Application.CreateForm(TFrmMainpopup, FrmMainpopup);
  Application.CreateForm(TFrmDummyAllwaysOnTopFix, FrmDummyAllwaysOnTopFix);
  AppendLog('TFrmMainpopup');

        FrmMainPopup.Visible := false;
        Application.OnException := FrmMainPopup.ApplicationException;

  Application.CreateForm(TFrmPermanentPreview, FrmPermanentPreview);
  AppendLog('TFrmPermanentPreview');
  Application.CreateForm(TFrmCheckForUpdate, FrmCheckForUpdate);
  AppendLog('TFrmCheckForUpdate');
  Application.CreateForm(TfrmSizeRichtext, frmSizeRichtext);
  AppendLog('TfrmSizeRichtext');
  Application.CreateForm(TFrmClipMenuNew, FrmClipMenuNew);
  AppendLog('TFrmClipMenuNew');

        Application.CreateForm(TFrmDummyInstance, FrmDummyInstance);
        FrmDummyInstance.Visible := false;
        AppendLog('FrmDummyInstance');
        Application.CreateForm(TFrmPermanentEdit, FrmPermanentEdit);
        AppendLog('FrmPermanentEdit');
        Application.CreateForm(TfrmClipboardBar, frmClipboardBar);
        AppendLog('frmClipboardBar');
        Application.CreateForm(TfrmSearch, frmSearch);
        AppendLog('frmSearch');
        Application.CreateForm(TfrmEditHistory, frmEditHistory);
        AppendLog('frmNewEditHistory');
        Application.CreateForm(TfrmPreviewPopup, frmPreviewPopup);
        AppendLog('frmPreviewPopup');
        Application.CreateForm(TFrmAbout, FrmAbout);
        AppendLog('FrmAbout');
        Application.CreateForm(TfrmClipboardManager, frmClipboardManager);
        AppendLog('frmClipboardManager');
        Application.CreateForm(TFrmHotkey, FrmHotkey);
        AppendLog('FrmHotkey');
        Application.CreateForm(TFrmPermanent, FrmPermanent);
        AppendLog('FrmPermanent');
        Application.CreateForm(TFrmPasteSelected, FrmPasteSelected);
        AppendLog('FrmPasteSelected');
        Application.CreateForm(TFrmEditItem, FrmEditItem);
        AppendLog('FrmEditItem');
        {Config must access other forms to set settings, making it last is safest}


        Application.CreateForm(TFrmConfig, FrmConfig);
        AppendLog('FrmConfig');
        if  par = '-paste' then begin
            ci := TClipItem.Create;
            ci.GetClipboardItem(0);
            Paste.SendText('', ci);
            Application.Terminate;
            EXIT;
        end;

        Application.CreateForm(TfrmSysTrayMenu, frmSysTrayMenu);
        AppendLog('frmSysTrayMenu');
        Application.CreateForm(TFrmChainWatcher, FrmChainWatcher);
        AppendLog('FrmChainWatcher');
        Application.CreateForm(TFrmReportError, FrmReportError);
        AppendLog('FrmReportError');
        Application.CreateForm(TFrmDummyUnicodeTooltip, FrmDummyUnicodeTooltip);
        AppendLog('FrmDummyUnicodeTooltip');
        Application.CreateForm(TFrmMove, FrmMove);
        AppendLog('FrmMove');
        Application.CreateForm(TFrmJumpList, FrmJumpList);
        AppendLog('FrmJumpList');

        // prevent clipboard messages until after all forms are loaded


        // a pinned icon activated jumplist when the program isn't running yet
        if (par <> '') and FrmJumpList.IsTaskArgument(par) then begin
            FrmJumpList.HandleTaskArgument(par);
        end;
        //UnitClipQueue.ResyncTempClipQueue;

        // testing to make sure the clipboard is not changing when the temp list
        // may be altered
        frmClipboardManager.ActivateAfterLoad;
        AppendLog('ClipboardManager - Activated');


         // must be AFTER Config and ClipboardBar
        if frmconfig.ClipboardBarSetVisible then begin
            frmconfig.LoadClipboardBarState;
        end;
    end;




    ShowWindow(Application.Handle, SW_HIDE);
    Application.Run;
    FrmInstance_DeInit;


end.
